<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;


class ScanCode extends \Zeedhi\Framework\Controller\Simple {

	protected $scanCodeService;

	public function __construct(\Service\ScanCode $scanCodeService) {
		$this->scanCodeService = $scanCodeService;
	}	
	
	public function changeState(Request\Row $request, Response $response){
		try {
			$params          = $request->getRow();
			$CDSETOR         = $params['CDSETOR'];
			$IDHABSCANCODE	 = $params['IDHABSCANCODE'];
			$scanCode = $this->scanCodeService->changeState($CDSETOR, $IDHABSCANCODE);

			$response->addDataSet(new DataSet('scanCode', array('success' => true, 'scanCode'=> $scanCode)));
		} catch (\Exception $e) {
			$response->addDataSet(new DataSet('scanCode', array('error' => true, 'message'=>$e->getMessage())));
		}
	}

	public function getOrderByUrl(Request\Row $request, Response $response){
		try {
			$params        = $request->getRow();
			$DSQRCODENFCE  = $params['DSQRCODENFCE'];
			$qrCode = $this->scanCodeService->getOrderByUrl($DSQRCODENFCE);

			$response->addDataSet(new DataSet('qrCode', array('success' => true, 'qrCode'=> $qrCode)));
		} catch (\Exception $e) {
			$response->addDataSet(new DataSet('qrCode', array('error' => true, 'message'=>$e->getMessage())));
		}
	}
	
}